// Decompiled by Jad v1.5.7f. Copyright 2000 Pavel Kouznetsov.
// Jad home page: http://www.geocities.com/SiliconValley/Bridge/8617/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   gjdoc/visitors/SyntaxToDocVisitor.java

package gjdoc.visitors;

import gj.util.Enumeration;
import gj.util.Vector;
import gjdoc.doctree.*;
import gjdoc.syntaxtree.*;
import gjdoc.syntaxvisitor.GJVoidDepthFirst;
import java.io.IOException;

// Referenced classes of package gjdoc.visitors:
//            StringVisitor, TypeVisitor

public class SyntaxToDocVisitor extends GJVoidDepthFirst
{

    public SyntaxToDocVisitor()
    {
    }

    public static boolean hasAccessSet(DocNode docnode)
    {
        return docnode.isPublic() || docnode.isProtected() || docnode.isPackagePrivate() || docnode.isPrivate();
    }

    public static void checkAccess(DocNode docnode)
    {
        if(!hasAccessSet(docnode))
            docnode.setAccess(docnode.getParent().getDefaultAccess());
    }

    public void visit(NodeToken nodetoken, DocNode docnode)
    {
        switch(Properties.Only.getProperty(nodetoken.toString()))
        {
        case 1: // '\001'
            docnode.setPublic(true);
            break;

        case 2: // '\002'
            docnode.setProtected(true);
            break;

        case 4: // '\004'
            docnode.setPackagePrivate(true);
            break;

        case 8: // '\b'
            docnode.setPrivate(true);
            break;

        case 16: // '\020'
            docnode.setStatic(true);
            break;

        case 32: // ' '
            docnode.setFinal(true);
            break;

        case 64: // '@'
            docnode.setTransient(true);
            break;

        case 128: 
            docnode.setVolatile(true);
            break;

        case 256: 
            docnode.setAbstract(true);
            break;

        case 512: 
            docnode.setNative(true);
            break;

        case 1024: 
            docnode.setSynchronized(true);
            break;
        }
        DocComment doccomment = docnode.getDocumentation();
        if(nodetoken.numSpecials() > 0 && !doccomment.isSealed())
        {
            String s = nodetoken.getSpecialAt(nodetoken.numSpecials() - 1).toString();
            if(s.substring(0, 3).equals("/**"))
                try
                {
                    docnode.setDocumentation(CommentParser.parse(CommentParser.trimAsterisks(s)));
                }
                catch(IOException ioexception) { }
        }
    }

    public void visit(NodeList nodelist, DocNode docnode)
    {
        int i = 0;
        for(Enumeration enumeration = nodelist.elements(); enumeration.hasMoreElements();)
        {
            ((Node)enumeration.nextElement()).accept(this, docnode);
            i++;
        }

    }

    public void visit(NodeListOptional nodelistoptional, DocNode docnode)
    {
        if(nodelistoptional.present())
        {
            int i = 0;
            for(Enumeration enumeration = nodelistoptional.elements(); enumeration.hasMoreElements();)
            {
                ((Node)enumeration.nextElement()).accept(this, docnode);
                i++;
            }

        }
    }

    public void visit(NodeSequence nodesequence, DocNode docnode)
    {
        int i = 0;
        for(Enumeration enumeration = nodesequence.elements(); enumeration.hasMoreElements();)
        {
            ((Node)enumeration.nextElement()).accept(this, docnode);
            i++;
        }

    }

    public void visit(CompilationUnit compilationunit, DocNode docnode)
    {
        DocPackage docpackage = new DocPackage(docnode);
        PackageDeclaration packagedeclaration = (PackageDeclaration)compilationunit.f0.node;
        String s = compilationunit.f0.present() ? (String)packagedeclaration.f1.accept(StringVisitor.Singleton) : "";
        docpackage.setName(s);
        docpackage.addImport(docpackage.getFullName() + ".*");
        docpackage.addImport("java.lang.*");
        compilationunit.f1.accept(this, docpackage);
        compilationunit.f2.accept(this, docpackage);
        docnode.addPackage(docpackage);
    }

    public void visit(ImportDeclaration importdeclaration, DocNode docnode)
    {
        String s = (String)importdeclaration.f1.accept(StringVisitor.Singleton) + (String)importdeclaration.f2.accept(StringVisitor.Singleton);
        docnode.addImport(s);
    }

    public void visit(TypeDeclaration typedeclaration, DocNode docnode)
    {
        typedeclaration.f0.accept(this, docnode);
    }

    public void visit(ClassDeclaration classdeclaration, DocNode docnode)
    {
        DocClass docclass = new DocClass(docnode);
        docclass.setImports(docnode.getImports());
        classdeclaration.f0.accept(this, docclass);
        classdeclaration.f1.accept(this, docclass);
        checkAccess(docclass);
        docnode.addClass(docclass);
    }

    public void visit(UnmodifiedClassDeclaration unmodifiedclassdeclaration, DocNode docnode)
    {
        Vector vector = new Vector();
        unmodifiedclassdeclaration.f0.accept(this, docnode);
        String s = docnode.getName() + unmodifiedclassdeclaration.f1.toString();
        docnode.setName(s);
        DocType doctype = (DocType)unmodifiedclassdeclaration.f2.accept(TypeVisitor.Singleton);
        ((DocClass)docnode).setTypeParams(doctype.getParameters());
        DocType doctype2 = (DocType)unmodifiedclassdeclaration.f3.accept(TypeVisitor.Singleton);
        if(!doctype2.getParameters().isEmpty())
        {
            doctype2 = (DocType)doctype2.getParameters().elementAt(0);
            ((DocClass)docnode).setSuper(doctype2);
        }
        if(unmodifiedclassdeclaration.f4.present())
        {
            NodeSequence nodesequence = (NodeSequence)unmodifiedclassdeclaration.f4.node;
            DocType doctype1 = (DocType)nodesequence.elementAt(1).accept(TypeVisitor.Singleton);
            vector = doctype1.getParameters();
        }
        ((DocClass)docnode).setImplemented(vector);
        unmodifiedclassdeclaration.f5.accept(this, docnode);
    }

    public void visit(ClassBody classbody, DocNode docnode)
    {
        classbody.f1.accept(this, docnode);
    }

    public void visit(NestedClassDeclaration nestedclassdeclaration, DocNode docnode)
    {
        DocClass docclass = new DocClass(docnode);
        nestedclassdeclaration.f0.accept(this, docclass);
        nestedclassdeclaration.f1.accept(this, docclass);
        docclass.setImports(docnode.getImports());
        checkAccess(docclass);
        docclass.setInner(true);
        docnode.addClass(docclass);
    }

    public void visit(ClassBodyDeclaration classbodydeclaration, DocNode docnode)
    {
        classbodydeclaration.f0.accept(this, docnode);
    }

    public void visit(NestedInterfaceDeclaration nestedinterfacedeclaration, DocNode docnode)
    {
        DocInterface docinterface = new DocInterface(docnode);
        nestedinterfacedeclaration.f0.accept(this, docinterface);
        nestedinterfacedeclaration.f1.accept(this, docinterface);
        docinterface.setImports(docnode.getImports());
        checkAccess(docinterface);
        docinterface.setInner(true);
        docnode.addInterface(docinterface);
    }

    public void visit(ConstructorDeclaration constructordeclaration, DocNode docnode)
    {
        DocCons doccons = new DocCons(docnode);
        constructordeclaration.f0.accept(this, doccons);
        String s = (String)constructordeclaration.f1.accept(StringVisitor.Singleton);
        doccons.setName(s);
        doccons.setImports(docnode.getImports());
        constructordeclaration.f2.accept(this, doccons);
        if(constructordeclaration.f3.present())
        {
            NodeSequence nodesequence = (NodeSequence)constructordeclaration.f3.node;
            DocType doctype = (DocType)nodesequence.elementAt(1).accept(TypeVisitor.Singleton);
            doccons.setExceptions(doctype.getParameters());
        }
        checkAccess(doccons);
        docnode.addConstructor(doccons);
    }

    public void visit(MethodDeclaration methoddeclaration, DocNode docnode)
    {
        DocMethod docmethod = new DocMethod(docnode);
        methoddeclaration.f0.accept(this, docmethod);
        docmethod.setTypeParams(((DocType)methoddeclaration.f1.accept(TypeVisitor.Singleton)).getParameters());
        methoddeclaration.f1.accept(this, docmethod);
        docmethod.setReturnType((DocType)methoddeclaration.f2.accept(TypeVisitor.Singleton));
        methoddeclaration.f2.accept(this, docmethod);
        if(methoddeclaration.f4.present())
        {
            NodeSequence nodesequence = (NodeSequence)methoddeclaration.f4.node;
            DocType doctype = (DocType)nodesequence.elementAt(1).accept(TypeVisitor.Singleton);
            docmethod.setExceptions(doctype.getParameters());
        }
        docmethod.setImports(docnode.getImports());
        methoddeclaration.f3.accept(this, docmethod);
        checkAccess(docmethod);
        docnode.addMethod(docmethod);
    }

    public void visit(MethodDeclarator methoddeclarator, DocNode docnode)
    {
        docnode.setName(methoddeclarator.f0.toString());
        methoddeclarator.f1.accept(this, docnode);
    }

    public void visit(FormalParameters formalparameters, DocNode docnode)
    {
        formalparameters.f1.accept(this, docnode);
    }

    public void visit(FormalParameter formalparameter, DocNode docnode)
    {
        DocParam docparam = new DocParam(docnode);
        formalparameter.f0.accept(this, docparam);
        docparam.setType((DocType)formalparameter.f1.accept(TypeVisitor.Singleton));
        docparam.setName((String)formalparameter.f2.accept(StringVisitor.Singleton));
        docparam.setImports(docnode.getImports());
        docnode.addArgument(docparam);
    }

    public void visit(InterfaceDeclaration interfacedeclaration, DocNode docnode)
    {
        DocInterface docinterface = new DocInterface(docnode);
        docinterface.setImports(docnode.getImports());
        interfacedeclaration.f0.accept(this, docinterface);
        interfacedeclaration.f1.accept(this, docinterface);
        docinterface.setPublic(true);
        docnode.addInterface(docinterface);
    }

    public void visit(UnmodifiedInterfaceDeclaration unmodifiedinterfacedeclaration, DocNode docnode)
    {
        Vector vector = new Vector();
        unmodifiedinterfacedeclaration.f0.accept(this, docnode);
        String s = docnode.getName() + unmodifiedinterfacedeclaration.f1.toString();
        docnode.setName(s);
        DocType doctype = (DocType)unmodifiedinterfacedeclaration.f2.accept(TypeVisitor.Singleton);
        ((DocInterface)docnode).setTypeParams(doctype.getParameters());
        if(unmodifiedinterfacedeclaration.f3.present())
        {
            NodeSequence nodesequence = (NodeSequence)unmodifiedinterfacedeclaration.f3.node;
            DocType doctype1 = (DocType)nodesequence.elementAt(1).accept(TypeVisitor.Singleton);
            vector = doctype1.getParameters();
        }
        ((DocInterface)docnode).setExtended(vector);
        unmodifiedinterfacedeclaration.f5.accept(this, docnode);
    }

    public void visit(InterfaceMemberDeclaration interfacememberdeclaration, DocNode docnode)
    {
        interfacememberdeclaration.f0.accept(this, docnode);
    }

    public void visit(FieldDeclaration fielddeclaration, DocNode docnode)
    {
        DocField docfield = new DocField(docnode);
        fielddeclaration.f2.accept(this, docfield);
        fielddeclaration.f0.accept(this, docfield);
        DocType doctype = (DocType)fielddeclaration.f1.accept(TypeVisitor.Singleton);
        fielddeclaration.f1.accept(this, docfield);
        docfield.setType(doctype);
        docfield.setImports(docnode.getImports());
        checkAccess(docfield);
        docnode.addField(docfield);
        int i = docfield.getProperties();
        String s = (String)fielddeclaration.f3.accept(StringVisitor.Singleton);
        String s1 = "";
        DocField docfield1;
        for(; s.length() > 0; docnode.addField(docfield1))
        {
            s = s.substring(1);
            int j = s.indexOf(44);
            j = j >= 0 ? j : s.length();
            String s2 = s.substring(0, j);
            s = s.substring(j);
            j = s2.indexOf(61);
            if(j >= 0)
                s2 = s2.substring(0, j);
            docfield1 = new DocField(docnode);
            docfield1.setName(s2);
            docfield1.setType(doctype);
            docfield1.setProperties(i);
        }

    }

    public void visit(VariableDeclarator variabledeclarator, DocNode docnode)
    {
        docnode.setName((String)variabledeclarator.f0.accept(StringVisitor.Singleton));
        variabledeclarator.f0.accept(this, docnode);
    }

    public void visit(TryStatement trystatement, Object obj)
    {
        super.visit(trystatement, (DocNode)obj);
    }

    public void visit(SynchronizedStatement synchronizedstatement, Object obj)
    {
        super.visit(synchronizedstatement, (DocNode)obj);
    }

    public void visit(ThrowStatement throwstatement, Object obj)
    {
        super.visit(throwstatement, (DocNode)obj);
    }

    public void visit(ReturnStatement returnstatement, Object obj)
    {
        super.visit(returnstatement, (DocNode)obj);
    }

    public void visit(ContinueStatement continuestatement, Object obj)
    {
        super.visit(continuestatement, (DocNode)obj);
    }

    public void visit(BreakStatement breakstatement, Object obj)
    {
        super.visit(breakstatement, (DocNode)obj);
    }

    public void visit(ForUpdate forupdate, Object obj)
    {
        super.visit(forupdate, (DocNode)obj);
    }

    public void visit(StatementExpressionList statementexpressionlist, Object obj)
    {
        super.visit(statementexpressionlist, (DocNode)obj);
    }

    public void visit(ForInit forinit, Object obj)
    {
        super.visit(forinit, (DocNode)obj);
    }

    public void visit(ForStatement forstatement, Object obj)
    {
        super.visit(forstatement, (DocNode)obj);
    }

    public void visit(DoStatement dostatement, Object obj)
    {
        super.visit(dostatement, (DocNode)obj);
    }

    public void visit(WhileStatement whilestatement, Object obj)
    {
        super.visit(whilestatement, (DocNode)obj);
    }

    public void visit(IfStatement ifstatement, Object obj)
    {
        super.visit(ifstatement, (DocNode)obj);
    }

    public void visit(SwitchLabel switchlabel, Object obj)
    {
        super.visit(switchlabel, (DocNode)obj);
    }

    public void visit(SwitchStatement switchstatement, Object obj)
    {
        super.visit(switchstatement, (DocNode)obj);
    }

    public void visit(StatementExpression statementexpression, Object obj)
    {
        super.visit(statementexpression, (DocNode)obj);
    }

    public void visit(EmptyStatement emptystatement, Object obj)
    {
        super.visit(emptystatement, (DocNode)obj);
    }

    public void visit(LocalVariableDeclaration localvariabledeclaration, Object obj)
    {
        super.visit(localvariabledeclaration, (DocNode)obj);
    }

    public void visit(BlockStatement blockstatement, Object obj)
    {
        super.visit(blockstatement, (DocNode)obj);
    }

    public void visit(Block block, Object obj)
    {
        super.visit(block, (DocNode)obj);
    }

    public void visit(LabeledStatement labeledstatement, Object obj)
    {
        super.visit(labeledstatement, (DocNode)obj);
    }

    public void visit(Statement statement, Object obj)
    {
        super.visit(statement, (DocNode)obj);
    }

    public void visit(ArrayDimensions arraydimensions, Object obj)
    {
        super.visit(arraydimensions, (DocNode)obj);
    }

    public void visit(AllocationExpression allocationexpression, Object obj)
    {
        super.visit(allocationexpression, (DocNode)obj);
    }

    public void visit(ArgumentList argumentlist, Object obj)
    {
        super.visit(argumentlist, (DocNode)obj);
    }

    public void visit(Arguments arguments, Object obj)
    {
        super.visit(arguments, (DocNode)obj);
    }

    public void visit(NullLiteral nullliteral, Object obj)
    {
        super.visit(nullliteral, (DocNode)obj);
    }

    public void visit(BooleanLiteral booleanliteral, Object obj)
    {
        super.visit(booleanliteral, (DocNode)obj);
    }

    public void visit(Literal literal, Object obj)
    {
        super.visit(literal, (DocNode)obj);
    }

    public void visit(PrimarySuffix primarysuffix, Object obj)
    {
        super.visit(primarysuffix, (DocNode)obj);
    }

    public void visit(PrimaryPrefix primaryprefix, Object obj)
    {
        super.visit(primaryprefix, (DocNode)obj);
    }

    public void visit(PrimaryExpression primaryexpression, Object obj)
    {
        super.visit(primaryexpression, (DocNode)obj);
    }

    public void visit(CastExpression castexpression, Object obj)
    {
        super.visit(castexpression, (DocNode)obj);
    }

    public void visit(PostfixExpression postfixexpression, Object obj)
    {
        super.visit(postfixexpression, (DocNode)obj);
    }

    public void visit(CastLookahead castlookahead, Object obj)
    {
        super.visit(castlookahead, (DocNode)obj);
    }

    public void visit(UnaryExpressionNotPlusMinus unaryexpressionnotplusminus, Object obj)
    {
        super.visit(unaryexpressionnotplusminus, (DocNode)obj);
    }

    public void visit(PreDecrementExpression predecrementexpression, Object obj)
    {
        super.visit(predecrementexpression, (DocNode)obj);
    }

    public void visit(PreIncrementExpression preincrementexpression, Object obj)
    {
        super.visit(preincrementexpression, (DocNode)obj);
    }

    public void visit(UnaryExpression unaryexpression, Object obj)
    {
        super.visit(unaryexpression, (DocNode)obj);
    }

    public void visit(MultiplicativeExpression multiplicativeexpression, Object obj)
    {
        super.visit(multiplicativeexpression, (DocNode)obj);
    }

    public void visit(AdditiveExpression additiveexpression, Object obj)
    {
        super.visit(additiveexpression, (DocNode)obj);
    }

    public void visit(RightAngledBracket rightangledbracket, Object obj)
    {
        super.visit(rightangledbracket, (DocNode)obj);
    }

    public void visit(RightShiftOp rightshiftop, Object obj)
    {
        super.visit(rightshiftop, (DocNode)obj);
    }

    public void visit(ShiftExpression shiftexpression, Object obj)
    {
        super.visit(shiftexpression, (DocNode)obj);
    }

    public void visit(RelationalExpression relationalexpression, Object obj)
    {
        super.visit(relationalexpression, (DocNode)obj);
    }

    public void visit(InstanceOfExpression instanceofexpression, Object obj)
    {
        super.visit(instanceofexpression, (DocNode)obj);
    }

    public void visit(EqualityExpression equalityexpression, Object obj)
    {
        super.visit(equalityexpression, (DocNode)obj);
    }

    public void visit(AndExpression andexpression, Object obj)
    {
        super.visit(andexpression, (DocNode)obj);
    }

    public void visit(ExclusiveOrExpression exclusiveorexpression, Object obj)
    {
        super.visit(exclusiveorexpression, (DocNode)obj);
    }

    public void visit(InclusiveOrExpression inclusiveorexpression, Object obj)
    {
        super.visit(inclusiveorexpression, (DocNode)obj);
    }

    public void visit(ConditionalAndExpression conditionalandexpression, Object obj)
    {
        super.visit(conditionalandexpression, (DocNode)obj);
    }

    public void visit(ConditionalOrExpression conditionalorexpression, Object obj)
    {
        super.visit(conditionalorexpression, (DocNode)obj);
    }

    public void visit(ConditionalExpression conditionalexpression, Object obj)
    {
        super.visit(conditionalexpression, (DocNode)obj);
    }

    public void visit(AssignmentOperator assignmentoperator, Object obj)
    {
        super.visit(assignmentoperator, (DocNode)obj);
    }

    public void visit(Assignment assignment, Object obj)
    {
        super.visit(assignment, (DocNode)obj);
    }

    public void visit(Expression expression, Object obj)
    {
        super.visit(expression, (DocNode)obj);
    }

    public void visit(NameList namelist, Object obj)
    {
        super.visit(namelist, (DocNode)obj);
    }

    public void visit(Name name, Object obj)
    {
        super.visit(name, (DocNode)obj);
    }

    public void visit(ResultType resulttype, Object obj)
    {
        super.visit(resulttype, (DocNode)obj);
    }

    public void visit(TypeBound typebound, Object obj)
    {
        super.visit(typebound, (DocNode)obj);
    }

    public void visit(TypeParameter typeparameter, Object obj)
    {
        super.visit(typeparameter, (DocNode)obj);
    }

    public void visit(TypeParameterList typeparameterlist, Object obj)
    {
        super.visit(typeparameterlist, (DocNode)obj);
    }

    public void visit(TypeParameters typeparameters, Object obj)
    {
        super.visit(typeparameters, (DocNode)obj);
    }

    public void visit(ReferenceTypeList referencetypelist, Object obj)
    {
        super.visit(referencetypelist, (DocNode)obj);
    }

    public void visit(TypeArguments typearguments, Object obj)
    {
        super.visit(typearguments, (DocNode)obj);
    }

    public void visit(ClassOrInterfaceType classorinterfacetype, Object obj)
    {
        super.visit(classorinterfacetype, (DocNode)obj);
    }

    public void visit(TypeVariable typevariable, Object obj)
    {
        super.visit(typevariable, (DocNode)obj);
    }

    public void visit(ArrayType arraytype, Object obj)
    {
        super.visit(arraytype, (DocNode)obj);
    }

    public void visit(ReferenceType referencetype, Object obj)
    {
        super.visit(referencetype, (DocNode)obj);
    }

    public void visit(PrimitiveType primitivetype, Object obj)
    {
        super.visit(primitivetype, (DocNode)obj);
    }

    public void visit(Type type, Object obj)
    {
        super.visit(type, (DocNode)obj);
    }

    public void visit(Initializer initializer, Object obj)
    {
        super.visit(initializer, (DocNode)obj);
    }

    public void visit(ExplicitConstructorInvocation explicitconstructorinvocation, Object obj)
    {
        super.visit(explicitconstructorinvocation, (DocNode)obj);
    }

    public void visit(ConstructorDeclaration constructordeclaration, Object obj)
    {
        visit(constructordeclaration, (DocNode)obj);
    }

    public void visit(FormalParameter formalparameter, Object obj)
    {
        visit(formalparameter, (DocNode)obj);
    }

    public void visit(FormalParameters formalparameters, Object obj)
    {
        visit(formalparameters, (DocNode)obj);
    }

    public void visit(MethodDeclarator methoddeclarator, Object obj)
    {
        visit(methoddeclarator, (DocNode)obj);
    }

    public void visit(MethodDeclaration methoddeclaration, Object obj)
    {
        visit(methoddeclaration, (DocNode)obj);
    }

    public void visit(ArrayInitializer arrayinitializer, Object obj)
    {
        super.visit(arrayinitializer, (DocNode)obj);
    }

    public void visit(VariableInitializer variableinitializer, Object obj)
    {
        super.visit(variableinitializer, (DocNode)obj);
    }

    public void visit(VariableDeclaratorId variabledeclaratorid, Object obj)
    {
        super.visit(variabledeclaratorid, (DocNode)obj);
    }

    public void visit(VariableDeclarator variabledeclarator, Object obj)
    {
        visit(variabledeclarator, (DocNode)obj);
    }

    public void visit(FieldDeclaration fielddeclaration, Object obj)
    {
        visit(fielddeclaration, (DocNode)obj);
    }

    public void visit(InterfaceMemberDeclaration interfacememberdeclaration, Object obj)
    {
        visit(interfacememberdeclaration, (DocNode)obj);
    }

    public void visit(UnmodifiedInterfaceDeclaration unmodifiedinterfacedeclaration, Object obj)
    {
        visit(unmodifiedinterfacedeclaration, (DocNode)obj);
    }

    public void visit(NestedInterfaceDeclaration nestedinterfacedeclaration, Object obj)
    {
        visit(nestedinterfacedeclaration, (DocNode)obj);
    }

    public void visit(InterfaceDeclaration interfacedeclaration, Object obj)
    {
        visit(interfacedeclaration, (DocNode)obj);
    }

    public void visit(FieldDeclarationLookahead fielddeclarationlookahead, Object obj)
    {
        super.visit(fielddeclarationlookahead, (DocNode)obj);
    }

    public void visit(MethodDeclarationLookahead methoddeclarationlookahead, Object obj)
    {
        super.visit(methoddeclarationlookahead, (DocNode)obj);
    }

    public void visit(ClassBodyDeclaration classbodydeclaration, Object obj)
    {
        visit(classbodydeclaration, (DocNode)obj);
    }

    public void visit(NestedClassDeclaration nestedclassdeclaration, Object obj)
    {
        visit(nestedclassdeclaration, (DocNode)obj);
    }

    public void visit(ClassBody classbody, Object obj)
    {
        visit(classbody, (DocNode)obj);
    }

    public void visit(UnmodifiedClassDeclaration unmodifiedclassdeclaration, Object obj)
    {
        visit(unmodifiedclassdeclaration, (DocNode)obj);
    }

    public void visit(ClassDeclaration classdeclaration, Object obj)
    {
        visit(classdeclaration, (DocNode)obj);
    }

    public void visit(TypeDeclaration typedeclaration, Object obj)
    {
        visit(typedeclaration, (DocNode)obj);
    }

    public void visit(ImportDeclaration importdeclaration, Object obj)
    {
        visit(importdeclaration, (DocNode)obj);
    }

    public void visit(PackageDeclaration packagedeclaration, Object obj)
    {
        super.visit(packagedeclaration, (DocNode)obj);
    }

    public void visit(CompilationUnit compilationunit, Object obj)
    {
        visit(compilationunit, (DocNode)obj);
    }

    public void visit(NodeToken nodetoken, Object obj)
    {
        visit(nodetoken, (DocNode)obj);
    }

    public void visit(NodeSequence nodesequence, Object obj)
    {
        visit(nodesequence, (DocNode)obj);
    }

    public void visit(NodeOptional nodeoptional, Object obj)
    {
        super.visit(nodeoptional, (DocNode)obj);
    }

    public void visit(NodeListOptional nodelistoptional, Object obj)
    {
        visit(nodelistoptional, (DocNode)obj);
    }

    public void visit(NodeList nodelist, Object obj)
    {
        visit(nodelist, (DocNode)obj);
    }

    public static SyntaxToDocVisitor Singleton = new SyntaxToDocVisitor();

}
